/*	Copyright (c) 1992 Linus Upson & The Geometry Center
	University of Minnesota
	1300 South Second Street
	Minneapolis, MN  55454, USA
	lupson@geom.umn.edu
*/

#import <appkit/appkit.h>

// Pick a reasonabe size prime number so we don't see patterns.
//  3671 is the  512th prime number.
//  8161 is the 1024th prime number.
// 17863 is the 2048th prime number.
// 38873 is the 4096th prime number.
// 84017 is the 8192th prime number.
#define NUM_POINTS 84017

@interface Scale:Object
{
    id	outSizeField;
	id	focusField;

	float scale;
	float focus;
	int samples;
	
	int outWidth, outHeight;
	int inWidth, inHeight;
	
	NXPoint jitterPoint[NUM_POINTS];
	NXPoint *jit, *jitMin, *jitMax;
	
	NXZone *scratchZone;
	BOOL tablesBuilt;
	BOOL freeStandardBitmap;
}

- init;
- resetJitterIndex;
- (NXBitmapImageRep *)filter:(NXBitmapImageRep *)bitmap;

@end
